/*====================================================================
EX.
%SCANAF(LIB=SAVE,CAT=ACCOUNT,STR=%NRSTR(TITLE),UPCASE=NO,REPORT=YES);
====================================================================*/

%MACRO SCANAF(LIB=,CAT=,STR=,UPCASE=YES,REPORT=YES);

 OPTIONS LS=132 PS=60 NOCENTER NODATE NONUMBER;
 FILENAME TEMP1 '&TEMP1';
 FILENAME TEMP2 '&TEMP2';

%IF &CAT= %THEN %DO;
 PROC PRINTTO FILE=TEMP1 NEW; RUN;
 PROC DATASETS LIB=&LIB NOLIST;
  CONTENTS DATA=&LIB.._ALL_ MEMTYPE=CATALOG;
 RUN; QUIT;
 PROC PRINTTO; RUN;

 DATA _NULL_;
  LENGTH LIBCAT $ 17;
  RETAIN SW 0;
  INFILE TEMP1;
  FILE TEMP2;
  INPUT @1 TEXT $CHAR80.;
  IF SCAN(TEXT,1,' ')='#'
   & SCAN(TEXT,2,' ') IN ('NAME',   'O')
   & SCAN(TEXT,3,' ') IN ('MEMTYPE','^Cv')
  THEN DO;
   SW=1;
   RETURN;
  END;
  IF VERIFY(TEXT,' -')=0 THEN RETURN;
  IF SW;
  LIBCAT=UPCASE(COMPRESS("&LIB"||.||SCAN(TEXT,2)));
  PUT @1 '%SEARCHAF(LIBCAT=' LIBCAT
                    ',STR=%NRSTR(' "&STR" '),UPCASE=' "&UPCASE" ');';
 RUN;
%END;
%ELSE %DO;
 DATA _NULL_;
  FILE TEMP2;
  LIBCAT=UPCASE(COMPRESS("&LIB"||'.'||"&CAT"));
  PUT @1 '%SEARCHAF(LIBCAT=' LIBCAT
                    ',STR=%NRSTR(' "&STR" '),UPCASE=' "&UPCASE" ');';
 RUN;
%END;

%MACRO SEARCHAF(LIBCAT=,STR=,UPCASE=);
 PROC DATASETS NOLIST; DELETE _REPORT; RUN; QUIT;

 FILENAME TEMP3 '&TEMP3';
 PROC BUILD C=&LIBCAT BATCH BROWSE;
  PRINT ENTRYTYPE=PROGRAM SOURCE PRTFILE=TEMP3;
  PRINT ENTRYTYPE=SCL     SOURCE PRTFILE=TEMP3 APPEND;
 RUN;

 DATA WORK._REPORT;
  LENGTH LIBCAT ENTRY $ 17 HEADLINE $ 40;
  RETAIN LIBCAT "&LIBCAT";
  RETAIN ENTRY HEADLINE;
  INFILE TEMP3 PAD;
  INPUT @1 TEXT $CHAR200.;
  IF _N_=1 THEN HEADLINE=TEXT;
  LINE+1;
  IF SCAN(TEXT,1,': ') IN ('ENTRY','Gg') THEN DO;
   ENTRY=SCAN(TEXT,2,': ');
   IF ENTRY NE LAG(ENTRY) THEN DO;
    LINE=1;
    INPUT /// @1 TEXT $CHAR200.;
   END;
   ELSE DO;
    LINE=LINE-4;
    INPUT   / @1 TEXT $CHAR200.;
   END;
  END;
 %IF &UPCASE=YES %THEN %DO;
  IF KINDEX(KUPCASE(TEXT),KUPCASE("&STR"));
 %END;
 %ELSE %DO;
  IF KINDEX(TEXT,"&STR");
 %END;
  IF SUBSTR(TEXT,1,40)=HEADLINE THEN DELETE;
  TEXT=LEFT(TEXT);
  KEEP LIBCAT ENTRY LINE TEXT;
 RUN;

 PROC APPEND BASE=WORK._REPORTS DATA=WORK._REPORT; RUN;

%MEND SEARCHAF;
 PROC DATASETS NOLIST; DELETE _REPORTS; RUN; QUIT;
 %INCLUDE TEMP2;

%IF &REPORT=YES %THEN %DO;
 OPTIONS LS=132 PS=60 NOCENTER DATE NUMBER PAGENO=1;
 TITLE1 "SEARCH STRING:&STR";
 PROC PRINT DATA=WORK._REPORTS UNIFORM;
  VAR LIBCAT ENTRY LINE TEXT;
 RUN;
 TITLE1;
%END;

%MEND SCANAF;

